"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.COLOR = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _color = _interopRequireDefault(require("color"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var steps = [];
var percent = 100;

for (var index = 8; index < percent; index += 8) {
  steps.push(index);
}

function shade(color) {
  var amount = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.08;
  return (0, _color["default"])(color).mix((0, _color["default"])(BASE_COLOR.BLACK), amount).toString();
}

function tint(color, amount) {
  return (0, _color["default"])(color).mix((0, _color["default"])(BASE_COLOR.WHITE), amount).toString();
}

function opaque(color, amount) {
  return (0, _color["default"])(color).fade(1 - amount).toString();
}

var BASE_COLOR = {
  BLACK: '#000',
  BLUE: '#0772de',
  GRAY: '#696c6e',
  GREEN: '#00c800',
  ORANGE: '#ff8900',
  RED: '#e02020',
  WHITE: '#fff',
  YELLOW: '#febf02'
};
var DARK_COLOR = {};
var LIGHT_COLOR = {};
var OPAQUE_COLOR = {};
Object.entries({
  BLACK: BASE_COLOR.BLACK,
  GRAY: BASE_COLOR.GRAY,
  WHITE: BASE_COLOR.WHITE
}).forEach(function (_ref) {
  var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      key = _ref2[0],
      value = _ref2[1];

  steps.forEach(function (step) {
    var amount = step / percent;
    DARK_COLOR["".concat(key, "_DARKEN_").concat(step)] = shade(value, amount);
    LIGHT_COLOR["".concat(key, "_LIGHTEN_").concat(step)] = tint(value, amount);
  });
});
Object.entries(BASE_COLOR).forEach(function (_ref3) {
  var _ref4 = (0, _slicedToArray2["default"])(_ref3, 2),
      key = _ref4[0],
      value = _ref4[1];

  steps.forEach(function (step) {
    var amount = step / percent;
    OPAQUE_COLOR["".concat(key, "_OPAQUE_").concat(step)] = opaque(value, amount);
  });
});
var COMPONENT_COLOR = {
  DISABLED: opaque(DARK_COLOR.GRAY_DARKEN_32, 0.16),
  ICON: DARK_COLOR.GRAY_DARKEN_72,
  LINK: DARK_COLOR.GRAY_DARKEN_72,
  TEXT: DARK_COLOR.GRAY_DARKEN_72
};

var COLOR = _objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread({}, BASE_COLOR), DARK_COLOR), LIGHT_COLOR), OPAQUE_COLOR), COMPONENT_COLOR), {}, {
  BLACK: BASE_COLOR.BLACK,
  WHITE: BASE_COLOR.WHITE,
  opaque: opaque,
  shade: shade,
  tint: tint
});

exports.COLOR = COLOR;
//# sourceMappingURL=colors.js.map